# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
import es, playerlib, cmdlib, langlib, gamethread, usermsg, urllib2, os, popuplib, cPickle
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxx # PATHS AND FILES # xxxxxxxx #
sampath     = es.getAddonPath('sam')
langPath    = sampath + '/langs/'
dbfolder    = 'sam_config/databases'
cfgPath     = 'cstrike/cfg/sam_config/'
addonscfg   = cfgPath + 'addons_cfg/'
cfgfile     = cfgPath + 'config.cfg'
reasonsfile = cfgPath + 'reasons.txt'
dlfile      = cfgPath + 'downloads.cfg'
dbPath      = cfgPath + 'databases/'
soundsPath  = 'cstrike/sound/sam_sounds'
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
if not os.path.exists(addonscfg): os.makedirs(addonscfg)
if not os.path.exists(cfgPath + 'databases'): os.makedirs(cfgPath + 'databases')
if not os.path.exists(cfgPath + 'addons_cfg'): os.makedirs(cfgPath + 'addons_cfg')
if not os.path.exists(soundsPath): os.makedirs(soundsPath)
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# x # VARIABLES/DICTIONARIES/LISTS # xx #
dev     = False
version = 'sam_version_full'
line    = '-' * 45
filters = ('#all','#human','#ct','#t','#alive','#dead','#spec','#bot')
cloud   = {'title':'ADMIN MENU','tag':'SAM','tagcolor':'#red','trigger':'!sam','version':es.ServerVar('sam_version_full'),'newversion':False,
		   'popups':[],'timeout':30,'filters':[],'cmds':{},'sayCMDS':[],'clientCMDS':[],'serverCMDS':[],'sounds_cache':{},'volume':1.0,'tell_sound':1}
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxxxxx # TAGS # xxxxxxxxxxxxxx #
updatetag   = '#purpleUPDATE SYSTEM'
errortag    = '#redERROR'
adminstag   = '#cyanADMINS SYSTEM'
servertag   = '#yellowSERVER'
teamstag    = '#beigeTEAMS'
settingstag = 'SETTINGS SYSTEM'
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxx # COLOR DICTIONARY # xxxxxxx #
colors = {'#t':'FF3D3D','#ct':'9BCDFF','#spec':'CDCDCD','#default':'FFB300','#brown':'A52A2A','#pink':'FF69B4','#red':'FF0000',
          '#darkred':'8B0000','#orange':'FFA500','#yellow':'FFFF00','#gold':'FFD700','#green':'00FF00','#darkgreen':'458B00',
          '#lightgreen':'9BFF9B','#cyan':'00FFFF','#blue':'0000FF','#darkblue':'00008B','#purple':'9B30FF','#darkpurple':'551A8B',
          '#white':'FFFFFF','#grey':'808080','#lightgrey':'D3D3D3','#darkgrey':'A9A9A9','#black':'000000','#beige':'F5F5DC','#dimgreen':'9EC34F'}
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# TRIGGER AND CMD
	SayCMD(cloud['trigger'], triggerCMD)
	ClientCMD('sam_menu', triggerCMD)
	ServerCMD('sam_trigger_cmd', modTriggerCMD)

	# CMDS
	SayCMD('!rcon', rconCMD)
	SayCMD('!sam_rcon', rconCMD)
	SayCMD('!admins', adminsCMD)
	SayCMD('!rr', rrCMD)
	SayCMD('!rserver', rsCMD)
	SayCMD('!unload', unloadCMD)
	SayCMD('!reload', reloadCMD)
	ServerCMD('sam_title_cmd', titleCMD)
	ServerCMD('sam_tag_cmd', tagCMD)
	ServerCMD('sam_tagcolor_cmd', tagcolorCMD)
	ServerCMD('sam_volume_cmd', volumeCMD)
	ServerCMD('sam_tell_sound_cmd', tellSoundCMD)

	# DOWNLOADS AND SETTINGS SYSTEMS
	downloads()
	create_config_files()

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# UNREGISTER CMDS
	unSayCMD('!rcon')
	unSayCMD('!sam_rcon')
	unSayCMD('!admins')
	unSayCMD('!rr')
	unSayCMD('!rserver')
	unSayCMD('!unload')
	unSayCMD('!reload')
	unSayCMD(cloud['trigger'])
	unClientCMD('sam_menu')
	unServerCMD('sam_trigger_cmd')
	unServerCMD('sam_title_cmd')
	unServerCMD('sam_tag_cmd')
	unServerCMD('sam_tagcolor_cmd')
	unServerCMD('sam_volume_cmd')
	unServerCMD('sam_tell_sound_cmd')

	# CANCEL DELAYS
	gamethread.cancelDelayed('sam_rs_delay')
	gamethread.cancelDelayed('sam_rs_loop')
	gamethread.cancelDelayed('sam_cmds_loop')

	# DELETE POPUPS CLOUD
	for popup in cloud['popups']: popupDelete(popup)

# =============================================================================== #
# === <<<> MESSAGE SYSTEM <>>> ================================================== #
# =============================================================================== #
def tell(users, text, tag=False, l=False):
	if tag: usermsg.saytext2(users, 0, """%s""" % takeColors('#default%s%s #grey| #black%s #grey| #default%s' % (cloud['tagcolor'],cloud['tag'], tag, text)))
	else: usermsg.saytext2(users, 0, """%s""" % takeColors('#default%s%s #grey| #default%s' % (cloud['tagcolor'],cloud['tag'], text)))
	if l: log(stripColors(text),stripColors(tag))

# ------------------------------------------------------------------------------- #
def say(users, text, l=False):
	usermsg.saytext2(users, 0, """%s""" % takeColors('#default%s' % text))
	if l: log(stripColors(text))

# ------------------------------------------------------------------------------- #
def hudhint(users, text, tag=False):
	if tag: usermsg.hudhint(users, stripColors('| %s |\n %s' % (tag,text)))
	else: usermsg.hudhint(users, stripColors('%s' % text))

# ------------------------------------------------------------------------------- #
def top(users, text, c='#white', time=5):
	if users in filters:
		for x in playerlib.getPlayerList(users): es.toptext(x, time, c, text)
	else: es.toptext(x, time, c, text)

# ------------------------------------------------------------------------------- #
def centermsg(users, text, l=False):
	usermsg.centermsg(users, text)
	if l: log(text,'CENTERMSG')

# ------------------------------------------------------------------------------- #
def keyhint(users, text): usermsg.keyhint(users, text.replace('\\n','').strip())

# ------------------------------------------------------------------------------- #
def motd(users, title, url): usermsg.motd(users, 2, 'SAM | %s'%title, url)

# ------------------------------------------------------------------------------- #
def log(MSG, TAG=False):
	MSG.replace('\n','').strip()
	if TAG: print('[SAM] %s | %s' % (stripColors(TAG),MSG))
	else: print('[SAM] %s' % MSG)

# =============================================================================== #
# === <<<> LANGUAGE SYSTEM <>>> ================================================= #
# =============================================================================== #
def langCore(name, tokens=None):
	langs = langlib.Strings(langPath + 'core.ini')
	return langs(name, tokens, 'en')

# ------------------------------------------------------------------------------- #
def langCommon(name, tokens=None):
	langs = langlib.Strings(langPath + 'common.ini')
	return langs(name, tokens, 'en')

# ------------------------------------------------------------------------------- #
def langAdmins(name, tokens=None):
	langs = langlib.Strings(langPath + 'admins.ini')
	return langs(name, tokens, 'en')

# ------------------------------------------------------------------------------- #
def langPcontrol(name, tokens=None):
	langs = langlib.Strings(langPath + 'pcontrol.ini')
	return langs(name, tokens, 'en')

# ------------------------------------------------------------------------------- #
def langAddon(addon, name, tokens=None):
	langs = langlib.Strings(langPath + '/addons/%s.ini' % addon)
	return langs(name, tokens, 'en')

# =============================================================================== #
# === <<<> DATABASE SYSTEM <>>> ================================================= #
# =============================================================================== #
def getDB(DB):
	if os.path.isfile(dbPath+DB):
		f    = open(dbPath+DB, 'rb')
		data = cPickle.load(f)
		f.close()
		log('%s LOADED.'%DB, 'DATABASE SYSTEM')
		return data
	else: return {}

# ------------------------------------------------------------------------------- #
def saveDB(DB, DATA):
	if len(list(DATA)):
		f = open(dbPath+DB, 'wb')
		cPickle.dump(DATA, f)
		f.close()
		log('%s SAVED.'%DB, 'DATABASE SYSTEM')
	elif os.path.isfile(dbPath+DB): os.remove(dbPath+DB)

# =============================================================================== #
# === <<<> DOWNLOADS SYSTEM <>>> ================================================ #
# =============================================================================== #
def downloads():
	log('REFRESHING DOWNLOADABLES.','DOWNLOADS SYSTEM')
	if os.path.isfile(dlfile): os.remove(dlfile)
	f = open(dlfile,'w')
	f.write('// - - - - - - - - - - - - - - - - - - - - - - -\n')
	f.write('//  Source Admin Menu # Downloads file\n')
	f.write('// - - - - - - - - - - - - - - - - - - - - - - -\n')
	f.write('//\n')
	f.write('//  Do not edit this file unless you are sure of what your doing!\n')
	f.write('//\n')
	f.write('// - - - - - - - - - - - - - - - - - - - - - - -\n \n')
	for path in get_sounds(): f.write('downloadable "%s"\n' % path.replace('cstrike/','').replace('/','\\'))
	f.close()
	es.server.insertcmd('exec sam_config/downloads.cfg')

# ------------------------------------------------------------------------------- #
def get_sounds(): return [path+'/'+sound for path, dirs, files in os.walk(soundsPath) for sound in files if sound.endswith(('.mp3','.wav'))]

# =============================================================================== #
# === <<<> SETTINGS SYSTEM <>>> ================================================= #
# =============================================================================== #
def create_config_files():
	if not os.path.isfile(cfgfile):
		a = {'trigger':'Command to access the menu.','title':'Title for all the menus.','tag':'Your community/team/group tag.',
			 'tagcolor':'Color for you tag. EXP: red, blue, green, yellow, purple, etc.','volume':'Volume of all sounds played by SAM.',
			 'tell_sound':'Displays to the player the name of the sound being played (Max: 1.0 | Min: 0.0)'}
		cfg = open(cfgfile,'w')
		cfg.write('// %s\n' % ('-' * 50))
		cfg.write('//  Source Admin Menu | Global Configuration File\n')
		cfg.write('// %s\n' % ('-' * 50))
		cfg.write('//  * Do not restart the server after changing any commands!\n')
		cfg.write('//  * Any changes will take effect within 10 seconds after you save this file.\n')
		cfg.write('// %s\n \n' % ('-' * 50))
		for x in a:
			cfg.write('// %s\n' % a[x])
			cfg.write('//\n')
			cfg.write('// Default: %s\n' % str(cloud[x]).strip('#'))
			cfg.write('sam_%s_cmd %s\n \n' % (x,str(cloud[x]).strip('#')))
		cfg.close()
		log('Global Configuration File created.',settingstag)
	if not os.path.isfile(reasonsfile):
		f = open(reasonsfile,'w')
		f.write('# - - - - - - - - - - - - - - - - - - #\n')
		f.write('#  Source Admin Menu # Reasons file   #\n')
		f.write('# - - - - - - - - - - - - - - - - - - #\n')
		f.write('#\n')
		f.write('#  These are the reasons for banning and kicking players.\n')
		f.write('#\n')
		f.write('# - - - - - - - - - - - - - - - - - - #\n \n')
		f.write('Disrespecting admins\n')
		f.write('Disrespecting Server rules\n')
		f.write('Chat spaming / Micro noise\n')
		f.write('Cheating with Aimbot\n')
		f.write('Cheating with SpeedHack\n')
		f.write('Cheating with wallhack')
		f.close()
		log('Reasons File created.',settingstag)
	gamethread.delayedname(1, 'sam_cmds_loop', execConfigs, (5))

# ------------------------------------------------------------------------------- #
def execConfigs(delay):
	cfglist = {}
	for item in os.listdir(addonscfg): cfglist[item] = addonscfg+item
	cfglist['config.cfg'] = cfgfile
	monitor = es.import_addon('sam/core/monitor')
	for x in cfglist:
		if x != 'config.cfg':
			if int(monitor.get(x.replace('.cfg',''),'state')): es.server.insertcmd('exec %s' % cfglist[x].replace('cstrike/cfg/',''))
		else: es.server.insertcmd('exec %s' % cfglist[x].replace('cstrike/cfg/',''))
	gamethread.delayedname(delay, 'sam_cmds_loop', execConfigs, (5))

# =============================================================================== #
# === <<<> UPDATE SYSTEM <>>> =================================================== #
# =============================================================================== #
def update(msg=False):
	if not dev:
		log('Checking for updates.',updatetag)
		try:
			url = urllib2.urlopen('http://www.skinngaming.com/sam/version.txt')
			cloud['newversion'] = str(url.read())
			url.close()
			if cloud['newversion'] == cloud['version']:
				cloud['newversion'] = False
				if msg: tell('#all', langCore('UPDATED', cloud), updatetag)
			elif msg: tell('#all', langCore('OUTDATED', cloud), updatetag)
		except:
			if msg: tell('#all', '#t'+langCore('NO_CONNECTION'), updatetag)

# =============================================================================== #
# === <<<> FUNCTIONS <>>> ======================================================= #
# =============================================================================== #
def takeColors(text):
	for x in colors: text = text.replace(x,'\x07'+colors[x])
	return _compile(text)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def stripColors(MSG):
	if MSG:
		for x in colors: MSG = MSG.replace(x,'')
		return _compile(MSG)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def _compile(TEXT):
	for x in ('\\n','\\r','\\t'): TEXT = TEXT.replace(x,'')
	return TEXT

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def convert(steamid):
    x, y, z = str(steamid).split(':')
    return (int(z)*2) + 76561197960265728L + int(y)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def percentage(PART, WHOLE=100):
	if bool(PART): return 100*PART/WHOLE
	else: return 0

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def SayCMD(CMD, CALLBACK, DESC='SAM CMD'): cmdlib.registerSayCommand(CMD, CALLBACK, DESC)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def ClientCMD(CMD, CALLBACK, DESC='SAM CMD'): cmdlib.registerClientCommand(CMD, CALLBACK, DESC)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def ServerCMD(CMD, CALLBACK, DESC='SAM CMD'): cmdlib.registerServerCommand(CMD, CALLBACK, DESC)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def unSayCMD(CMD): cmdlib.unregisterSayCommand(CMD)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def unClientCMD(CMD): cmdlib.unregisterClientCommand(CMD)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def unServerCMD(CMD): cmdlib.unregisterServerCommand(CMD)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def sound(target, sound, volume=1, attenuation=0.5): es.emitsound('player', target, sound, volume, attenuation)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def play(user, sound, volume=None):
	if not volume: volume = cloud['volume']
	s = sound.split('/')
	s = s[len(s)-1].replace('.mp3','').replace('.wav','')
	if user in filters:
		l = playerlib.getPlayerList(user)
		for x in l:
			stopsound(x.userid)
			cloud['sounds_cache'][x.userid] = sound
			es.playsound(x, sound, volume)
		if cloud['tell_sound']: hudhint(user, langCore('NOW_PLAYING',{'sound':s}),'SAM')
	else:
		x = es.getuserid(user)
		stopsound(x)
		cloud['sounds_cache'][x] = sound
		es.playsound(x, sound, volume)
		if cloud['tell_sound']: hudhint(x, langCore('NOW_PLAYING',{'sound':s}),'SAM')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def stopsound(target):

	if target in cloud['sounds_cache']: es.server.insertcmd('es_stopsound %s %s' % (target,cloud['sounds_cache'][target]))

# xxx ### POPUPS ### xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxzxxxx #
def header(module=None):
	if module: return '%s | SAM v%s\n \n :: %s ' % (cloud['title'],cloud['version'],module.upper())
	else: return '%s | SAM %s\n \n:: ' % (cloud['title'],cloud['version'])

# ------------------------------------------------------------------------------- #
def popupDelete(name):
	if popuplib.exists(name):
		popup = popuplib.find(name)
		popup.recache(users=[])
		popup.delete()
	if name in cloud['popups']: cloud['popups'].remove(name)

# ------------------------------------------------------------------------------- #
def sendPage(index,x=7,p=1):
	while x <= index:
		x += 7
		p += 1
	else: return p

# ------------------------------------------------------------------------------- #
def easymenu(POPUP, SUBMENU=None,TIMEOUT=True):
	NAME, BLOCK = POPUP
	popupDelete(NAME)
	if not NAME in cloud['popups']: cloud['popups'].append(NAME)
	POPUP = popuplib.easymenu(NAME, None, BLOCK)
	POPUP.c_beginsep = line
	POPUP.c_pagesep  = line
	if SUBMENU: POPUP.submenu(10, SUBMENU)
	POPUP.recache(users=[])
	return POPUP

# ------------------------------------------------------------------------------- #
def simplemenu(NAME,SUBMENU=None,TIMEOUT=True):
	popupDelete(NAME)
	if not NAME in cloud['popups']: cloud['popups'].append(NAME)
	popup = popuplib.create(NAME)
	if SUBMENU: popup.submenu(10, SUBMENU)
	popup.recache(users=[])
	return popup

# =============================================================================== #
# === <<<> CMD BLOCKS <>>> ====================================================== #
# =============================================================================== #
def modTriggerCMD(ARGS):
	args = ' '.join(ARGS)
	if not args.isdigit():
		if es.exists('saycommand', cloud['trigger']): unSayCMD(cloud['trigger'])
		cloud['trigger'] = args
		SayCMD(args, triggerCMD)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def triggerCMD(ID, ARGS):
	core = es.import_addon('sam/core')
	core.home(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def adminsCMD(ID, ARGS):
	admins = es.import_addon('sam/core/admins')
	LIST   = [ply.name for ply in playerlib.getPlayerList('#all') if admins.isAdmin(ply)]
	if len(LIST): tell(ID, '#ct%s#default.' % '#default, #ct'.join(LIST),'#cyanADMINS ONLINE')
	else: tell(ID, langCore('NOADMINS'), adminstag)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def rrCMD(ID, ARGS):
	admins = es.import_addon('sam/core/admins')
	if admins.can(ID,'Server Commands'):
		es.server.insertcmd('mp_restartgame 1')
		tell('#all',langCore('RR'),servertag)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def rsCMD(ID, ARGS, SEC=None):
	if not SEC:
		admins = es.import_addon('sam/core/admins')
		if admins.can(ID,'Server Commands') and admins.can(ID,'Server Restart'):
			rsCMD(None, None, 5)
			gamethread.delayedname(5,'sam_rs_delay',es.server.insertcmd,('_restart'))
	elif SEC > 0:
		hudhint('#all',langCore('RS',{'sec':SEC}),servertag)
		gamethread.delayedname(1,'sam_rs_loop',rsCMD,(None, None, SEC-1))

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def titleCMD(ARGS):
	if ARGS:
		args = str(' '.join(ARGS))
		if len(args) < 16: cloud['title'] = args.strip('"')
		else: log('Title cant have more than 15 characters.', errortag)
	else: log('This title will be on top of all pages.', errortag)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def tagCMD(ARGS):
	if ARGS:
		args = str(' '.join(ARGS))
		if len(args) < 6: cloud['tag'] = args
		else: log('Tag cant have more than 5 characters.', errortag)
	else: log('Tag to be displayed at the beggining of all messages.', errortag)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def tagcolorCMD(ARGS):
	if ARGS:
		args = str(' '.join(ARGS))
		args = '#%s'%args.lower().replace('#','')
		if args in colors: cloud['tagcolor'] = args
		else: log('That color does not exist.', errortag)
	else: log('Changes chat tag color.', errortag)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def volumeCMD(ARGS):
	if ARGS:
		try:
			ARGS = str(' '.join(ARGS))
			r    = [round(x * 0.1, 1) for x in range(0, 11)]
			if float(ARGS) in r or int(ARGS) == 1: cloud['volume'] = float(ARGS) + 0.0
			else: log('Argument must be a float in range 0.0 to 1.0.', errortag)
		except: log('Argument must be a float in range 0.0 to 1.0.', errortag)
	else: log('Volume of all sounds played by SAM.', errortag)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def tellSoundCMD(ARGS):
	if ARGS:
		try:
			ARGS = int(' '.join(ARGS))
			if ARGS in (1,0): cloud['tell_sound'] = ARGS
		except: pass

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def unloadCMD(ID, ARGS):
	admins = es.import_addon('sam/core/admins')
	if admins.can(ID,'Server Commands'): es.unload('sam')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def reloadCMD(ID, ARGS):
	admins = es.import_addon('sam/core/admins')
	if admins.can(ID,'Server Commands'): es.reload('sam')

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def rconCMD(ID, ARGS):
	admins = es.import_addon('sam/core/admins')
	if admins.can(ID,'Server RCON') and ARGS:
		cmd = ARGS[0]
		ARGS.remove(cmd)
		args = ' '.join(ARGS)
		if es.exists('variable', cmd) or es.exists('command', cmd):
			var = False
			if es.exists('variable', cmd):
				var = es.ServerVar(cmd)
				var.removeFlag('notify')
			if ARGS:
				es.server.insertcmd('%s %s' % (cmd,args))
				for x in ('sam_','sv_','mp_','rate','cl_','rcon_'):
					if cmd.startswith(x): tell('#all', langCore('RCON_EXEC_CMD', {'cmd':cmd, 'args':args}), '#yellowRCON')
				if cmd in ('es_load','es_unload','es_reload'): tell('#all', langCore('RCON_ES_CMD', {'cmd':cmd.replace('es_','').upper(), 'args':args}), '#ctEVENTSCRIPTS')
			elif cmd.startswith('bot_'):
				es.server.insertcmd(cmd)
				tell('#all', langCore('RCON_EXEC_CMD_NOARGS', {'cmd':cmd}), '#yellowRCON')
			else: hudhint(ID, langCore('RCON_NOARGS'),errortag)
		else: hudhint(ID, langCore('RCON_NOTACMD',{'cmd':cmd}),errortag)

# =============================================================================== #
# === <<<> EVENTS <>>> ========================================================== #
# =============================================================================== #
def es_map_start(ev):
	downloads()
	update()
	for popup in cloud['popups']:
		if popuplib.exists(popup): popuplib.delete(popup)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def round_end(ev): update()

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def player_disconnect(ev):
	if 'cache' in cloud:
		if ev['userid'] in cloud['cache']: del cloud['cache'][ev['userid']]
	if ev['userid'] in cloud['sounds_cache']: del cloud['sounds_cache']

# =============================================================================== #